#include "liste_char.h"
#include <stdlib.h>
#include <stdio.h>

void init_liste_char (struct liste_char* L){
    L->tete = NIL;
    L->nbchar = 0;
}

void clear_liste_char (struct liste_char* L){
    struct maillon_char* tmp;
    struct maillon_char* suivant;
    
    int i = 0;
    tmp = L->tete;
    for(i = 0; i < L->nbchar; i++){
        suivant = tmp->next;
        free(tmp);
        tmp = suivant;
    }
}

void imprimer_liste_char (struct liste_char* L){
    
    if(L->tete == NIL){
        printf("EmptyList\n");
                
    }else{
        struct maillon_char* M;
        int i;
        M = L->tete;  
        for(i = 0; i < (L->nbchar); i++){
            printf("%c",M->value);
            M = M->next;
        }
    }  
    printf("\n");
}


/* 
 * Ajout d'un char en entête de liste 
 */
void ajouter_en_tete_liste_char (struct liste_char* L, char c){
    
     struct maillon_char* nouveau;
     
     nouveau = (struct maillon_char*)malloc(sizeof(struct maillon_char));
     if(nouveau == NIL){
        fprintf(stderr,"error: NoMoreMemory");
        exit(1);
     }
     
     nouveau->value= c;
     nouveau->next=L->tete;
     L->tete=nouveau;
     L->nbchar +=1;
     
}

void ajouter_en_queue_liste_char (struct liste_char* L, char c){
    if(L->tete == NIL){
        ajouter_en_tete_liste_char (L, c);
    }
    struct maillon_char* nouveau;
     
    nouveau = (struct maillon_char*)malloc(sizeof(struct maillon_char));
    if(nouveau == NIL){
        fprintf(stderr,"error: NoMoreMemory");
        exit(1);
    }
    struct maillon_char* m;
    m=L->tete;
    while(m->next!=NIL){
        m=m->next;
    }
    nouveau->value=c;
    nouveau->next=NIL;
    m->next=nouveau;
    L->nbchar +=1;
    
}
